<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from builder.texi on 28 April 1999 -->

<TITLE>The Builder Library - WHILE and DO Loops</TITLE>
<link href="builder_20.html" rel=Next>
<link href="builder_18.html" rel=Previous>
<link href="builder_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="builder_1.html">first</A>, <A HREF="builder_18.html">previous</A>, <A HREF="builder_20.html">next</A>, <A HREF="builder_47.html">last</A> section, <A HREF="builder_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC47" HREF="builder_toc.html#TOC47">WHILE and DO Loops</A></H2>
<P>
<A NAME="IDX121"></A>
<A NAME="IDX122"></A>
<A NAME="IDX123"></A>
A more general WHILE loop can be created using the builder's <CODE>WHILE()</CODE>
and <CODE>DO()</CODE> functions (which are equivalent). The first argument to
these functions is the test and the second argument is the body of the
loop. 
The builder's <CODE>WHILE()</CODE> and <CODE>DO()</CODE> functions get translated to
a SUIF LOOP macro instruction. 

</P>
<P>
For exampe, the following C loop:

<PRE>
        i = 0;
        while(i&#60;100) {
           i = i + 1;
           ...;
        }

Can be created by the following builder structure:

        block i(block::new_sym(cst_int, i));
        block code(block(block(i = block(0)),
                  block::WHILE(block(i &#60; block(100)),
                               block(block(i = i + block(1)),
                                     block(...)))));
</PRE>

<P>
<A NAME="IDX124"></A>

</P>

<P><HR><P>
<p>Go to the <A HREF="builder_1.html">first</A>, <A HREF="builder_18.html">previous</A>, <A HREF="builder_20.html">next</A>, <A HREF="builder_47.html">last</A> section, <A HREF="builder_toc.html">table of contents</A>.
</BODY>
</HTML>
